/*
 * File name: DemoLec09Gui.java
 * Date:      2014/11/09 18:04
 * Author:    Jan Faigl
 */
package cz.cvut.fel.pr1;

import java.awt.Color;

import java.io.IOException;

/**
 *
 * @author jf
 */
public class DemoLec09Gui {

    public void printToCanvas(Geom[] objects, Canvas canvas) {
        for (int i = 0; i < objects.length; ++i) {
            Geom obj = objects[i];
            if (obj instanceof Printable) {
                ((Printable) obj).printToCanvas(canvas);
            }
        }
    }

    /**
     *
     * @param objects
     * @param canvas
     * @param out
     */
    public void saveCanvas(GeomObjectArray geomObjects, ArrayBackedCanvas canvas, String out) {
        try {
            canvas.clearCanvas(Color.WHITE);
            printToCanvas(geomObjects.getArray(), canvas);
            canvas.writeToFile(out);
        } catch (IOException e) {
            System.err.println("Error: writing canvas to the file '" + out + "'");
        }
    }

    public void setColor(Geom[] objects, Color color) {
        for (int i = 0; i < objects.length; ++i) {
            objects[i].setColor(color);
        }
    }

    /**
     * @param objects
     * @param largeObject
     * @param color
     */
    public void markColorInside(Geom[] objects, Geom largeObject, Color color) {
        if (objects == null || largeObject == null || color == null) {
            return;
        }
        for (int i = 0; i < objects.length; ++i) {
            Geom obj = objects[i];
            if (obj != null && largeObject.isInside(obj)) {
                obj.setColor(color);
            }
        }
    }

    /**
     *
     * @param args
     */
    public void start(String[] args) {
        Point pt1 = new Point(320, 240);
        System.out.println("pt1: " + pt1);

        Circle c1 = new Circle(new Point(100, 100), 50);
        Point pt2 = new Point(75, 75);
        Point pt3 = new Point(125, 125);

        Segment s1 = new Segment(pt1, pt2);
        Segment s2 = new Segment(pt2, pt3);

        Circle c2 = new Circle(new Point(400, 400), 400);
        c2.setColor(new Color(255, 130, 71)); //RoyalBlue

        GeomObjectArray geomObjects = new GeomObjectArray();
        geomObjects.add(pt1).add(pt2).add(pt3).add(s1).add(s2);
        geomObjects.add(c1).add(c2);

        ArrayBackedCanvas canvas = new ArrayBackedCanvas(640, 480);
        saveCanvas(geomObjects, canvas, "objects.png");

        markColorInside(geomObjects.getArray(), c1, Color.RED);
        saveCanvas(geomObjects, canvas, "objects-inside_circle-c1.png");

        setColor(geomObjects.getArray(), Color.BLUE);
        markColorInside(geomObjects.getArray(), c2, Color.ORANGE);
        saveCanvas(geomObjects, canvas, "objects-inside_circle-c2.png");

    }
}
