/*
 * File name: GeomObjectArray.java
 * Date:      2014/11/10 20:28
 * Author:    Jan Faigl
 */
package cz.cvut.fel.pr1;

/**
 *
 *
 */
public class GeomObjectArray {

    private Geom[] objects;
    private int size;
    private final int DEFAULT_SIZE_RESERVE = 100;

    /**
     *
     */
    public GeomObjectArray() {
        objects = new Geom[DEFAULT_SIZE_RESERVE]; //create the initial capacity 
    }

    /**
     *
     * @param obj
     * @return
     */
    public GeomObjectArray add(Geom obj) {
        if (size == objects.length) { //reallocate the array
            Geom[] objectsNew = new Geom[objects.length + DEFAULT_SIZE_RESERVE];
            for (int i = 0; i < objects.length; ++i) {
                objectsNew[i] = objects[i];
            }
            objects = objectsNew; //replace the array
        }
        objects[size++] = obj;
        return this;
    }

    /**
     *
     * @return
     */
    public Geom[] getArray() {
        Geom[] ret = new Geom[size];
        for (int i = 0; i < size; ++i) {
            ret[i] = objects[i];
        }
        return ret;
    }

}
